clear all; clc; close all;


load MM.mat 
load MMN10.mat 
load MME10.mat 
load MMS10.mat 
load MMW10.mat

%% CHOOSE DATES

% from = '08-Mar-1990 04:00:00'; % [dd-mm-yyyy hh:00:00] ex: '08-Mar-1990 04:00:00' (I: 1589) PS: (00->23h)
% to   = '10-Mar-1990 07:00:00'; % [dd-mm-yyyy hh:00:00]


from = '08-Mar-1990 04:00:00'; % [dd-mm-yyyy hh:00:00] ex: '08-Mar-1990 04:00:00' (I: 1589) PS: (00->23h)
to   = '08-Mar-1992 07:00:00'; % [dd-mm-yyyy hh:00:00]

% finding the index row for the specific to and from dates 
% LIK FOR ALLE!
IndexFrom = find(contains(MM,from));
IndexTo   = find(contains(MM,to));
rowF = IndexFrom;
rowT = IndexTo;


% Lage kjempematrise med xvel1 yvel1 xvel2 yvel2... -> ingen endring index

 % wind (column 5) and deeper current (< 100m) (column 16-22) 
 % wind (column 2) and deeper current (< 100m) (column 13-19) 
 

% TRAINING DATASET

a1 = 2:3;    %wind
a2 = 4:5;    %0m
a3 = 6:7;    %10m
a4 = 8:9;    %20m
a5 = 10:11;  %30m
a6 = 12:13;  %40m
a7 = 14:15;  %50m
a8 = 16:17;  %60m
a9 = 18:19;  %70m
a10 = 20:21; %80m
a11 = 22:23; %90m
a12 = 24:25; %100m
a13 = 26:27; %125m
a14 = 28:29; %150m
a15 = 30:31; %175m
a16 = 32:33; %200m
a17 = 34:35; %250m
a18 = 36:37; %300m

f1 = rowF:rowT;
f2 = rowF-1:rowT-1;
f3 = rowF-2:rowT-2;
f4 = rowF-3:rowT-3;
f5 = rowF-4:rowT-4;
f6 = rowF-5:rowT-5;
f7 = rowF-6:rowT-6;
f8 = rowF-7:rowT-7;

% legge til for andre gridpunkter MMN10(f1,a1) 
tn  = [ MM(f1,a1) MM(f1,a2)  MM(f1,a3)  MM(f1,a4)  MM(f1,a5)  MM(f1,a6)  MM(f1,a7)  MM(f1,a8) MM(f1,a9) MM(f1,a10) MM(f1,a11) MM(f1,a12) MM(f1,a13) MM(f1,a14) MM(f1,a15) MM(f1,a16) MM(f1,a17) MM(f1,a18) ]; % tn
tn1 = [ MM(f2,a1) MM(f2,a2)  MM(f2,a3)  MM(f2,a4)  MM(f2,a5)  MM(f2,a6)  MM(f2,a7)  MM(f2,a8) MM(f2,a9) MM(f2,a10) MM(f2,a11) MM(f2,a12) MM(f2,a13) MM(f2,a14) MM(f2,a15) MM(f2,a16) MM(f2,a17) MM(f2,a18) ]; % tn-1
tn2 = [ MM(f3,a1) MM(f3,a2)  MM(f3,a3)  MM(f3,a4)  MM(f3,a5)  MM(f3,a6)  MM(f3,a7)  MM(f3,a8) MM(f3,a9) MM(f3,a10) MM(f3,a11) MM(f3,a12) MM(f3,a13) MM(f3,a14) MM(f3,a15) MM(f3,a16) MM(f3,a17) MM(f3,a18) ]; % tn-2
tn3 = [ MM(f4,a1) MM(f4,a2)  MM(f4,a3)  MM(f4,a4)  MM(f4,a5)  MM(f4,a6)  MM(f4,a7)  MM(f4,a8) MM(f4,a9) MM(f4,a10) MM(f4,a11) MM(f4,a12) MM(f4,a13) MM(f4,a14) MM(f4,a15) MM(f4,a16) MM(f4,a17) MM(f4,a18) ]; % tn-3
tn4 = [ MM(f5,a1) MM(f5,a2)  MM(f5,a3)  MM(f5,a4)  MM(f5,a5)  MM(f5,a6)  MM(f5,a7)  MM(f5,a8) MM(f5,a9) MM(f5,a10) MM(f5,a11) MM(f5,a12) MM(f5,a13) MM(f5,a14) MM(f5,a15) MM(f5,a16) MM(f5,a17) MM(f5,a18) ]; % tn-4
tn5 = [ MM(f6,a1) MM(f6,a2)  MM(f6,a3)  MM(f6,a4)  MM(f6,a5)  MM(f6,a6)  MM(f6,a7)  MM(f6,a8) MM(f6,a9) MM(f6,a10) MM(f6,a11) MM(f6,a12) MM(f6,a13) MM(f6,a14) MM(f6,a15) MM(f6,a16) MM(f6,a17) MM(f6,a18) ]; % tn-5
tn6 = [ MM(f7,a1) MM(f7,a2)  MM(f7,a3)  MM(f7,a4)  MM(f7,a5)  MM(f7,a6)  MM(f7,a7)  MM(f7,a8) MM(f7,a9) MM(f7,a10) MM(f7,a11) MM(f7,a12) MM(f7,a13) MM(f7,a14) MM(f7,a15) MM(f7,a16) MM(f7,a17) MM(f7,a18) ]; % tn-6
tn7 = [ MM(f8,a1) MM(f8,a2)  MM(f8,a3)  MM(f8,a4)  MM(f8,a5)  MM(f8,a6)  MM(f8,a7)  MM(f8,a8) MM(f8,a9) MM(f8,a10) MM(f8,a11) MM(f8,a12) MM(f8,a13) MM(f8,a14) MM(f8,a15) MM(f8,a16) MM(f8,a17) MM(f8,a18) ]; % tn-7

tnN10  = [ MMN10(f1,a1) MMN10(f1,a2)  MMN10(f1,a3)  MMN10(f1,a4)  MMN10(f1,a5)  MMN10(f1,a6)  MMN10(f1,a7)  MMN10(f1,a8) MMN10(f1,a9) MMN10(f1,a10) MMN10(f1,a11) MMN10(f1,a12) MMN10(f1,a13) MMN10(f1,a14) MMN10(f1,a15) MMN10(f1,a16) MMN10(f1,a17) MMN10(f1,a18) ]; % tn
tn1N10 = [ MMN10(f2,a1) MMN10(f2,a2)  MMN10(f2,a3)  MMN10(f2,a4)  MMN10(f2,a5)  MMN10(f2,a6)  MMN10(f2,a7)  MMN10(f2,a8) MMN10(f2,a9) MMN10(f2,a10) MMN10(f2,a11) MMN10(f2,a12) MMN10(f2,a13) MMN10(f2,a14) MMN10(f2,a15) MMN10(f2,a16) MMN10(f2,a17) MMN10(f2,a18) ]; % tn-1
tn2N10 = [ MMN10(f3,a1) MMN10(f3,a2)  MMN10(f3,a3)  MMN10(f3,a4)  MMN10(f3,a5)  MMN10(f3,a6)  MMN10(f3,a7)  MMN10(f3,a8) MMN10(f3,a9) MMN10(f3,a10) MMN10(f3,a11) MMN10(f3,a12) MMN10(f3,a13) MMN10(f3,a14) MMN10(f3,a15) MMN10(f3,a16) MMN10(f3,a17) MMN10(f3,a18) ]; % tn-2
tn3N10 = [ MMN10(f4,a1) MMN10(f4,a2)  MMN10(f4,a3)  MMN10(f4,a4)  MMN10(f4,a5)  MMN10(f4,a6)  MMN10(f4,a7)  MMN10(f4,a8) MMN10(f4,a9) MMN10(f4,a10) MMN10(f4,a11) MMN10(f4,a12) MMN10(f4,a13) MMN10(f4,a14) MMN10(f4,a15) MMN10(f4,a16) MMN10(f4,a17) MMN10(f4,a18) ]; % tn-3
tn4N10 = [ MMN10(f5,a1) MMN10(f5,a2)  MMN10(f5,a3)  MMN10(f5,a4)  MMN10(f5,a5)  MMN10(f5,a6)  MMN10(f5,a7)  MMN10(f5,a8) MMN10(f5,a9) MMN10(f5,a10) MMN10(f5,a11) MMN10(f5,a12) MMN10(f5,a13) MMN10(f5,a14) MMN10(f5,a15) MMN10(f5,a16) MMN10(f5,a17) MMN10(f5,a18) ]; % tn-4
tn5N10 = [ MMN10(f6,a1) MMN10(f6,a2)  MMN10(f6,a3)  MMN10(f6,a4)  MMN10(f6,a5)  MMN10(f6,a6)  MMN10(f6,a7)  MMN10(f6,a8) MMN10(f6,a9) MMN10(f6,a10) MMN10(f6,a11) MMN10(f6,a12) MMN10(f6,a13) MMN10(f6,a14) MMN10(f6,a15) MMN10(f6,a16) MMN10(f6,a17) MMN10(f6,a18) ]; % tn-5
tn6N10 = [ MMN10(f7,a1) MMN10(f7,a2)  MMN10(f7,a3)  MMN10(f7,a4)  MMN10(f7,a5)  MMN10(f7,a6)  MMN10(f7,a7)  MMN10(f7,a8) MMN10(f7,a9) MMN10(f7,a10) MMN10(f7,a11) MMN10(f7,a12) MMN10(f7,a13) MMN10(f7,a14) MMN10(f7,a15) MMN10(f7,a16) MMN10(f7,a17) MMN10(f7,a18) ]; % tn-6
tn7N10 = [ MMN10(f8,a1) MMN10(f8,a2)  MMN10(f8,a3)  MMN10(f8,a4)  MMN10(f8,a5)  MMN10(f8,a6)  MMN10(f8,a7)  MMN10(f8,a8) MMN10(f8,a9) MMN10(f8,a10) MMN10(f8,a11) MMN10(f8,a12) MMN10(f8,a13) MMN10(f8,a14) MMN10(f8,a15) MMN10(f8,a16) MMN10(f8,a17) MMN10(f8,a18) ]; % tn-7

tnE10  = [ MME10(f1,a1) MME10(f1,a2)  MME10(f1,a3)  MME10(f1,a4)  MME10(f1,a5)  MME10(f1,a6)  MME10(f1,a7)  MME10(f1,a8) MME10(f1,a9) MME10(f1,a10) MME10(f1,a11) MME10(f1,a12) MME10(f1,a13) MME10(f1,a14) MME10(f1,a15) MME10(f1,a16) MME10(f1,a17) MME10(f1,a18) ]; % tn
tn1E10 = [ MME10(f2,a1) MME10(f2,a2)  MME10(f2,a3)  MME10(f2,a4)  MME10(f2,a5)  MME10(f2,a6)  MME10(f2,a7)  MME10(f2,a8) MME10(f2,a9) MME10(f2,a10) MME10(f2,a11) MME10(f2,a12) MME10(f2,a13) MME10(f2,a14) MME10(f2,a15) MME10(f2,a16) MME10(f2,a17) MME10(f2,a18) ]; % tn-1
tn2E10 = [ MME10(f3,a1) MME10(f3,a2)  MME10(f3,a3)  MME10(f3,a4)  MME10(f3,a5)  MME10(f3,a6)  MME10(f3,a7)  MME10(f3,a8) MME10(f3,a9) MME10(f3,a10) MME10(f3,a11) MME10(f3,a12) MME10(f3,a13) MME10(f3,a14) MME10(f3,a15) MME10(f3,a16) MME10(f3,a17) MME10(f3,a18) ]; % tn-2
tn3E10 = [ MME10(f4,a1) MME10(f4,a2)  MME10(f4,a3)  MME10(f4,a4)  MME10(f4,a5)  MME10(f4,a6)  MME10(f4,a7)  MME10(f4,a8) MME10(f4,a9) MME10(f4,a10) MME10(f4,a11) MME10(f4,a12) MME10(f4,a13) MME10(f4,a14) MME10(f4,a15) MME10(f4,a16) MME10(f4,a17) MME10(f4,a18) ]; % tn-3
tn4E10 = [ MME10(f5,a1) MME10(f5,a2)  MME10(f5,a3)  MME10(f5,a4)  MME10(f5,a5)  MME10(f5,a6)  MME10(f5,a7)  MME10(f5,a8) MME10(f5,a9) MME10(f5,a10) MME10(f5,a11) MME10(f5,a12) MME10(f5,a13) MME10(f5,a14) MME10(f5,a15) MME10(f5,a16) MME10(f5,a17) MME10(f5,a18) ]; % tn-4
tn5E10 = [ MME10(f6,a1) MME10(f6,a2)  MME10(f6,a3)  MME10(f6,a4)  MME10(f6,a5)  MME10(f6,a6)  MME10(f6,a7)  MME10(f6,a8) MME10(f6,a9) MME10(f6,a10) MME10(f6,a11) MME10(f6,a12) MME10(f6,a13) MME10(f6,a14) MME10(f6,a15) MME10(f6,a16) MME10(f6,a17) MME10(f6,a18) ]; % tn-5
tn6E10 = [ MME10(f7,a1) MME10(f7,a2)  MME10(f7,a3)  MME10(f7,a4)  MME10(f7,a5)  MME10(f7,a6)  MME10(f7,a7)  MME10(f7,a8) MME10(f7,a9) MME10(f7,a10) MME10(f7,a11) MME10(f7,a12) MME10(f7,a13) MME10(f7,a14) MME10(f7,a15) MME10(f7,a16) MME10(f7,a17) MME10(f7,a18) ]; % tn-6
tn7E10 = [ MME10(f8,a1) MME10(f8,a2)  MME10(f8,a3)  MME10(f8,a4)  MME10(f8,a5)  MME10(f8,a6)  MME10(f8,a7)  MME10(f8,a8) MME10(f8,a9) MME10(f8,a10) MME10(f8,a11) MME10(f8,a12) MME10(f8,a13) MME10(f8,a14) MME10(f8,a15) MME10(f8,a16) MME10(f8,a17) MME10(f8,a18) ]; % tn-7

tnW10  = [ MMW10(f1,a1) MMW10(f1,a2)  MMW10(f1,a3)  MMW10(f1,a4)  MMW10(f1,a5)  MMW10(f1,a6)  MMW10(f1,a7)  MMW10(f1,a8) MMW10(f1,a9) MMW10(f1,a10) MMW10(f1,a11) MMW10(f1,a12) MMW10(f1,a13) MMW10(f1,a14) MMW10(f1,a15) MMW10(f1,a16) MMW10(f1,a17) MMW10(f1,a18) ]; % tn
tn1W10 = [ MMW10(f2,a1) MMW10(f2,a2)  MMW10(f2,a3)  MMW10(f2,a4)  MMW10(f2,a5)  MMW10(f2,a6)  MMW10(f2,a7)  MMW10(f2,a8) MMW10(f2,a9) MMW10(f2,a10) MMW10(f2,a11) MMW10(f2,a12) MMW10(f2,a13) MMW10(f2,a14) MMW10(f2,a15) MMW10(f2,a16) MMW10(f2,a17) MMW10(f2,a18) ]; % tn-1
tn2W10 = [ MMW10(f3,a1) MMW10(f3,a2)  MMW10(f3,a3)  MMW10(f3,a4)  MMW10(f3,a5)  MMW10(f3,a6)  MMW10(f3,a7)  MMW10(f3,a8) MMW10(f3,a9) MMW10(f3,a10) MMW10(f3,a11) MMW10(f3,a12) MMW10(f3,a13) MMW10(f3,a14) MMW10(f3,a15) MMW10(f3,a16) MMW10(f3,a17) MMW10(f3,a18) ]; % tn-2
tn3W10 = [ MMW10(f4,a1) MMW10(f4,a2)  MMW10(f4,a3)  MMW10(f4,a4)  MMW10(f4,a5)  MMW10(f4,a6)  MMW10(f4,a7)  MMW10(f4,a8) MMW10(f4,a9) MMW10(f4,a10) MMW10(f4,a11) MMW10(f4,a12) MMW10(f4,a13) MMW10(f4,a14) MMW10(f4,a15) MMW10(f4,a16) MMW10(f4,a17) MMW10(f4,a18) ]; % tn-3
tn4W10 = [ MMW10(f5,a1) MMW10(f5,a2)  MMW10(f5,a3)  MMW10(f5,a4)  MMW10(f5,a5)  MMW10(f5,a6)  MMW10(f5,a7)  MMW10(f5,a8) MMW10(f5,a9) MMW10(f5,a10) MMW10(f5,a11) MMW10(f5,a12) MMW10(f5,a13) MMW10(f5,a14) MMW10(f5,a15) MMW10(f5,a16) MMW10(f5,a17) MMW10(f5,a18) ]; % tn-4
tn5W10 = [ MMW10(f6,a1) MMW10(f6,a2)  MMW10(f6,a3)  MMW10(f6,a4)  MMW10(f6,a5)  MMW10(f6,a6)  MMW10(f6,a7)  MMW10(f6,a8) MMW10(f6,a9) MMW10(f6,a10) MMW10(f6,a11) MMW10(f6,a12) MMW10(f6,a13) MMW10(f6,a14) MMW10(f6,a15) MMW10(f6,a16) MMW10(f6,a17) MMW10(f6,a18) ]; % tn-5
tn6W10 = [ MMW10(f7,a1) MMW10(f7,a2)  MMW10(f7,a3)  MMW10(f7,a4)  MMW10(f7,a5)  MMW10(f7,a6)  MMW10(f7,a7)  MMW10(f7,a8) MMW10(f7,a9) MMW10(f7,a10) MMW10(f7,a11) MMW10(f7,a12) MMW10(f7,a13) MMW10(f7,a14) MMW10(f7,a15) MMW10(f7,a16) MMW10(f7,a17) MMW10(f7,a18) ]; % tn-6
tn7W10 = [ MMW10(f8,a1) MMW10(f8,a2)  MMW10(f8,a3)  MMW10(f8,a4)  MMW10(f8,a5)  MMW10(f8,a6)  MMW10(f8,a7)  MMW10(f8,a8) MMW10(f8,a9) MMW10(f8,a10) MMW10(f8,a11) MMW10(f8,a12) MMW10(f8,a13) MMW10(f8,a14) MMW10(f8,a15) MMW10(f8,a16) MMW10(f8,a17) MMW10(f8,a18) ]; % tn-7

tnS10  = [ MMS10(f1,a1) MMS10(f1,a2)  MMS10(f1,a3)  MMS10(f1,a4)  MMS10(f1,a5)  MMS10(f1,a6)  MMS10(f1,a7)  MMS10(f1,a8) MMS10(f1,a9) MMS10(f1,a10) MMS10(f1,a11) MMS10(f1,a12) MMS10(f1,a13) MMS10(f1,a14) MMS10(f1,a15) MMS10(f1,a16) MMS10(f1,a17) MMS10(f1,a18) ]; % tn
tn1S10 = [ MMS10(f2,a1) MMS10(f2,a2)  MMS10(f2,a3)  MMS10(f2,a4)  MMS10(f2,a5)  MMS10(f2,a6)  MMS10(f2,a7)  MMS10(f2,a8) MMS10(f2,a9) MMS10(f2,a10) MMS10(f2,a11) MMS10(f2,a12) MMS10(f2,a13) MMS10(f2,a14) MMS10(f2,a15) MMS10(f2,a16) MMS10(f2,a17) MMS10(f2,a18) ]; % tn-1
tn2S10 = [ MMS10(f3,a1) MMS10(f3,a2)  MMS10(f3,a3)  MMS10(f3,a4)  MMS10(f3,a5)  MMS10(f3,a6)  MMS10(f3,a7)  MMS10(f3,a8) MMS10(f3,a9) MMS10(f3,a10) MMS10(f3,a11) MMS10(f3,a12) MMS10(f3,a13) MMS10(f3,a14) MMS10(f3,a15) MMS10(f3,a16) MMS10(f3,a17) MMS10(f3,a18) ]; % tn-2
tn3S10 = [ MMS10(f4,a1) MMS10(f4,a2)  MMS10(f4,a3)  MMS10(f4,a4)  MMS10(f4,a5)  MMS10(f4,a6)  MMS10(f4,a7)  MMS10(f4,a8) MMS10(f4,a9) MMS10(f4,a10) MMS10(f4,a11) MMS10(f4,a12) MMS10(f4,a13) MMS10(f4,a14) MMS10(f4,a15) MMS10(f4,a16) MMS10(f4,a17) MMS10(f4,a18) ]; % tn-3
tn4S10 = [ MMS10(f5,a1) MMS10(f5,a2)  MMS10(f5,a3)  MMS10(f5,a4)  MMS10(f5,a5)  MMS10(f5,a6)  MMS10(f5,a7)  MMS10(f5,a8) MMS10(f5,a9) MMS10(f5,a10) MMS10(f5,a11) MMS10(f5,a12) MMS10(f5,a13) MMS10(f5,a14) MMS10(f5,a15) MMS10(f5,a16) MMS10(f5,a17) MMS10(f5,a18) ]; % tn-4
tn5S10 = [ MMS10(f6,a1) MMS10(f6,a2)  MMS10(f6,a3)  MMS10(f6,a4)  MMS10(f6,a5)  MMS10(f6,a6)  MMS10(f6,a7)  MMS10(f6,a8) MMS10(f6,a9) MMS10(f6,a10) MMS10(f6,a11) MMS10(f6,a12) MMS10(f6,a13) MMS10(f6,a14) MMS10(f6,a15) MMS10(f6,a16) MMS10(f6,a17) MMS10(f6,a18) ]; % tn-5
tn6S10 = [ MMS10(f7,a1) MMS10(f7,a2)  MMS10(f7,a3)  MMS10(f7,a4)  MMS10(f7,a5)  MMS10(f7,a6)  MMS10(f7,a7)  MMS10(f7,a8) MMS10(f7,a9) MMS10(f7,a10) MMS10(f7,a11) MMS10(f7,a12) MMS10(f7,a13) MMS10(f7,a14) MMS10(f7,a15) MMS10(f7,a16) MMS10(f7,a17) MMS10(f7,a18) ]; % tn-6
tn7S10 = [ MMS10(f8,a1) MMS10(f8,a2)  MMS10(f8,a3)  MMS10(f8,a4)  MMS10(f8,a5)  MMS10(f8,a6)  MMS10(f8,a7)  MMS10(f8,a8) MMS10(f8,a9) MMS10(f8,a10) MMS10(f8,a11) MMS10(f8,a12) MMS10(f8,a13) MMS10(f8,a14) MMS10(f8,a15) MMS10(f8,a16) MMS10(f8,a17) MMS10(f8,a18) ]; % tn-7

X = [ tn tnN10 tnE10 tnS10 tnW10 tn1 tn1N10 tn1E10 tn1S10 tn1W10 tn2 tn2N10 tn2E10 tn2S10 tn2W10 tn3 tn3N10 tn3E10 tn3S10 tn3W10 tn4 tn4N10 tn4E10 tn4S10 tn4W10 tn5 tn5N10 tn5E10 tn5S10 tn5W10 tn6 tn6N10 tn6E10 tn6S10 tn6W10 tn7 tn7N10 tn7E10 tn7S10 tn7W10  ]; % predictor matrix
X = str2double(X);

diffFT = rowT - rowF;
g1 = (rowT+1):(rowT+diffFT+1);
% g2 = rowF-1:rowT-1; g1-1;
% g3 = rowF-2:rowT-2;
% g4 = rowF-3:rowT-3;
% g5 = rowF-4:rowT-4;
% g6 = rowF-5:rowT-5;
% g7 = rowF-6:rowT-6;
% g8 = rowF-7:rowT-7;

% t1 = [ MM(f1,a1) MM(f1,a2)  MM(f1,a3)  MM(f1,a4)  MM(f1,a5)  MM(f1,a6)  MM(f1,a7)  MM(f1,a8) ]; % tn FULL
t1 = [ MM(f1,a2)  MM(f1,a3)  MM(f1,a4)  MM(f1,a5)  MM(f1,a6)  MM(f1,a7)  MM(f1,a8) ]; % tn FULL

Y = [ t1 ]; % response matrix
Y = str2double(Y);





% TESTING DATASET

h1 = g1+1;
h2 = h1-1;
h3 = h2-2;
h4 = h3-3;
h5 = h4-4;
h6 = h5-5;
h7 = h6-6;
h8 = h7-7;


tn_2  = [ MM(h1,a1) MM(h1,a2)  MM(h1,a3)  MM(h1,a4)  MM(h1,a5)  MM(h1,a6)  MM(h1,a7)  MM(h1,a8) ]; % tn
tn1_2 =  [ MM(h2,a1) MM(h2,a2)  MM(h2,a3)  MM(h2,a4)  MM(h2,a5)  MM(h2,a6)  MM(h2,a7)  MM(h2,a8) ]; % tn-1
tn2_2 =   [ MM(h3,a1) MM(h3,a2)  MM(h3,a3)  MM(h3,a4)  MM(h3,a5)  MM(h3,a6)  MM(h3,a7)  MM(h3,a8) ]; % tn-2
tn3_2 =    [ MM(h4,a1) MM(h4,a2)  MM(h4,a3)  MM(h4,a4)  MM(h4,a5)  MM(h4,a6)  MM(h4,a7)  MM(h4,a8) ]; % tn-3
tn4_2 =     [ MM(h5,a1) MM(h5,a2)  MM(h5,a3)  MM(h5,a4)  MM(h5,a5)  MM(h5,a6)  MM(h5,a7)  MM(h5,a8) ]; % tn-4
tn5_2 =      [ MM(h6,a1) MM(h6,a2)  MM(h6,a3)  MM(h6,a4)  MM(h6,a5)  MM(h6,a6)  MM(h6,a7)  MM(h6,a8) ]; % tn-5
tn6_2 =       [ MM(h7,a1) MM(h7,a2)  MM(h7,a3)  MM(h7,a4)  MM(h7,a5)  MM(h7,a6)  MM(h7,a7)  MM(h7,a8) ]; % tn-6
tn7_2 =        [ MM(h8,a1) MM(h8,a2)  MM(h8,a3)  MM(h8,a4)  MM(h8,a5)  MM(h8,a6)  MM(h8,a7)  MM(h8,a8) ]; % tn-7

X2 = [ tn_2 tn1_2 tn2_2 tn3_2 tn4_2 tn5_2 tn6_2 tn7_2 ]; % predictor matrix
X2 = str2double(X2);

diffFT = rowT - rowF;
g1 = (rowT+1):(rowT+diffFT+1);
% g2 = rowF-1:rowT-1; g1-1;
% g3 = rowF-2:rowT-2;
% g4 = rowF-3:rowT-3;
% g5 = rowF-4:rowT-4;
% g6 = rowF-5:rowT-5;
% g7 = rowF-6:rowT-6;
% g8 = rowF-7:rowT-7;

% t1 = [ MM(f1,a1) MM(f1,a2)  MM(f1,a3)  MM(f1,a4)  MM(f1,a5)  MM(f1,a6)  MM(f1,a7)  MM(f1,a8) ]; % tn FULL

%        100m xy  -  125 xy  -  150 xy  -  175 xy  -  200 xy  -  250 xy  -  300 xy
t1_2 = [ MM(h1,a2)  MM(h1,a3)  MM(h1,a4)  MM(h1,a5)  MM(h1,a6)  MM(h1,a7)  MM(h1,a8) ]; % tn FULL

Y2 = [ t1_2 ]; % response matrix
Y2 = str2double(Y2);


%% PLSR analysis

% PARTIAL LEAST SQUARES REGRESSION

ncomp = 35; % 14 30 8
time  = linspace(1,1000,1000);
components = 1:16;

% TRAINING THE ALGORITHM
[XL,YL,XS,YS,BETA,PCTvar,MSE,stats] = plsregress(X,Y,ncomp);

[n,p] = size(X);

yFit_train = [ones(n,1) X]*BETA; 

diff_train = Y - yFit_train; % blir residuals..?


% TESTING THE BETA on test set
yFit_test = [ones(n,1) X2]*BETA(1:129,:);


%% plotting
set(0,'DefaultLineLineWidth', 1.5);
set(0,'DefaultAxesXGrid','on','DefaultAxesYGrid','on');
set(0,'DefaultLineMarkerSize', 8);
% set(0,'DefaultAxesMarkerSize',8);


[rowY,colY] = size(Y);

% figure
% plot(1:colY,yFit_train,1:colY,yFit_test);
% legend('xvelTrain','yvelTrain','xvelTest','yvelTest')
% title('Fitted x- and y-velocities for training set and testing set')

figure
plot(1:colY,sum(yFit_train)/rowY,'.',1:colY,sum(yFit_test)/rowY,'.','MarkerSize',12); % RGB ,'Color',[.8 .2 0]
legend('xy-Train','xy-Test','Location','N')
title('Fitted SUM/rows of x- and y-velocities for training set and testing set')
% ser at det er liten total forskjell p hver enkelt av dem
xticks([1 2 3 4 5 6 7 8 9 10 11 12 13 14])
xticklabels({'x100','y100','x125','y125','x150','y150','x175','y175','x200','y200','x250','y250','x300','y300'})


%% CALCULATING THE ERROR

error = (yFit_test - yFit_train).^2;

figure
%plot(1:ncomp,error);
plot(1:colY,sum(error)/rowY);
% legend('x100','y100','x125','y125','x150','y150','x175','y175','x200','y200','x250','y250','x300','y300') % fix x-ticks til heltall?
title('Squared error or sum error (between test and train) of x-and y-velocities')
% xticklabels({'0','x100','y100','x125','y125','x150','y150','x175','y175','x200','y200','x250','y250','x300','y300'})

% larger error for deeper currents!

%%
% PLOTTING CUMULATIVE VARIANCE EXPLAINED IN Y

figure
plot(1:ncomp,cumsum(100*PCTvar(2,:)),'-bo');
xlabel('Number of components used')
ylabel('Cumulative percent')
title('Cumulative percent variance explained in Y depending on number of components used')
axis([1 ncomp 0 100]);


%% PLOTTING Y-MATRICES VS yFIT MATRICES

figure
plot(Y',yFit_train','.',Y2',yFit_test','.','MarkerSize',14); hold on;
% legend('xvelTrain','yvelTrain','xvelTest','yvelTest','Location','SE')
legend('x100','y100','x125','y125','x150','y150','x175','y175','x200','y200','x250','y250','x300','y300','Location','SE')
title(['Y train and Y test vs yFit train and yFit test with ncomp = ',num2str(ncomp)]);

  % grey linear line in the background
x = linspace(-.002,.02,10);
y = x;
plot(x,y,'--','Color',[.5 .5 .5]')
grid on
%%

figure
plot(Y2',yFit_test','.','MarkerSize',12);

%%
figure
% ser bare p xvel p 100m - se p dem hver for seg. 
% plot(Y(:,1)',yFit_train(:,1)','.',Y2(:,1)',yFit_test(:,1)','.','MarkerSize',14);
% plot(Y(:,2)',yFit_train(:,2)','.',Y2(:,2)',yFit_test(:,2)','.','MarkerSize',14);
% plot(Y(:,3)',yFit_train(:,3)','.',Y2(:,3)',yFit_test(:,3)','.','MarkerSize',14);
% plot(Y(:,4)',yFit_train(:,4)','.',Y2(:,4)',yFit_test(:,4)','.','MarkerSize',14);
% plot(Y(:,5)',yFit_train(:,5)','.',Y2(:,5)',yFit_test(:,5)','.','MarkerSize',14);
% plot(Y(:,6)',yFit_train(:,6)','.',Y2(:,6)',yFit_test(:,6)','.','MarkerSize',14);
% plot(Y(:,7)',yFit_train(:,7)','.',Y2(:,7)',yFit_test(:,7)','.','MarkerSize',14);
% plot(Y(:,8)',yFit_train(:,8)','.',Y2(:,8)',yFit_test(:,8)','.','MarkerSize',14);
% plot(Y(:,9)',yFit_train(:,9)','.',Y2(:,9)',yFit_test(:,9)','.','MarkerSize',14);
% plot(Y(:,10)',yFit_train(:,10)','.',Y2(:,10)',yFit_test(:,10)','.','MarkerSize',14);
% plot(Y(:,11)',yFit_train(:,11)','.',Y2(:,11)',yFit_test(:,11)','.','MarkerSize',14);
% plot(Y(:,12)',yFit_train(:,12)','.',Y2(:,12)',yFit_test(:,12)','.','MarkerSize',14);
% plot(Y(:,13)',yFit_train(:,13)','.',Y2(:,13)',yFit_test(:,13)','.','MarkerSize',14);
% plot(Y(:,14)',yFit_train(:,14)','.',Y2(:,14)',yFit_test(:,14)','.','MarkerSize',14);









